package alist;
public class Alist {

    private int kapasite;
    private int elemSayisi;
    private int[] dizi;

    public Alist(){
        kapasite = 5;
        elemSayisi = 0;
        dizi = new int[kapasite];
    }

    public void add(int e){
        if(elemSayisi == kapasite)
            dizi = kapasiteArtir();

        dizi[elemSayisi] = e;
        elemSayisi++;
    }

    public void add(int poz, int e) throws Exception{

        if (poz < 0 || poz > elemSayisi) {
            System.out.println("HATA: "+poz +". pozisyona "+e+" "
                    + "değeri ekleme işleminiz tamamlanamadı. "
                    + "Girilen pozisyon değeri geçersiz."
                    + "(Girilebilecek maksimum pozisyon değeri : "+elemSayisi+ ")");
            return;
        }

        if(poz == kapasite)
            dizi = kapasiteArtir();

        for(int i=size(); i>=poz; i--)
            dizi[i+1] = dizi[i];

        dizi[poz] = e;
        elemSayisi++;
    }


    public void remove(int poz){
        if(poz < 0 || poz > elemSayisi-1)
        {
            System.out.println("HATA: "+poz +". pozisyonudaki değeri "
                    + "silme işleminiz tamamlanamadı. "
                    + "Girilen pozisyon değeri geçersiz."
                    + "(Girilebilecek maksimum pozisyon değeri : "+elemSayisi+ ")");
            return;
        }

        int p = 0;
        
        while(p != poz){
            p++;
        }
        
        for(int i=p; i<elemSayisi-1 ; i++){
            dizi[i] = dizi[i+1];
        }
        
        elemSayisi--;
    }

    public int indexOf(int e){
        for(int i=0; i<elemSayisi; i++){
            if(e == dizi[i]){
                return i;
            }
        }

        return -1;
    }

    public int lastIndexOf(int e){ 
        for(int i=elemSayisi; i>0; i--){
            if(e == dizi[i]){
                return i;
            }
        }

        return -1;
    }

    public boolean clear(){
        elemSayisi=0;
        return true;
    }

    public boolean isEmpty(){
        if(elemSayisi == 0)
            return true;
        else
            return false;
    }

    public int first(){
        if(elemSayisi == 0)
            return -1;
        return dizi[0];
    }

    public int last(){
        return dizi[elemSayisi-1];
    }

    public int get(int poz){
        return dizi[poz];
    }

    public int size(){
        return elemSayisi;
    }

    public void print(){
        for(int i=0; i<size(); i++)
            System.out.print(get(i)+" ");

        System.out.println("");
    }

    private int[] kapasiteArtir() {
        int[] yeniDizi = new int[kapasite*2];

        for(int i=0; i<kapasite; i++){
            yeniDizi[i] = dizi[i];
        }

        kapasite *= 2;

        return yeniDizi;
    }


}
